package net.lapinblanc.android.rssreader;

import java.io.FileNotFoundException;
import android.database.sqlite.*;
import android.database.*;


public class Database {
	private SQLiteDatabase db;
	private RSSreader rss;
	
	public Database (RSSreader rss) {
		this.rss = rss;
		open ();
	}
	
	private void open () {
		try {
			db = rss.openDatabase ("rssreader", null);
		}
        catch (FileNotFoundException e) {
			// Create the database
			createDb ();
			open ();
        }

	}
	
    public Cursor list () {
    	/* Return a Cursor on a list of stored RSS feeds */
    	String [] selectionArgs = {};
    	String [] columns = {"_id", "url", "visit"};
    	
    	return db.query (true, "feed", columns, null, selectionArgs, null, null, null);
    }
    
    public void add (String url) {
    	/*ContentValues content;
    	
    	content = new ContentValues ();
    	
    	content.put("feed", url);
    	content.put("visit", 0);*/

    	/* Insert feed into the database */
    	db.execSQL("INSERT INTO feed(url, visit) VALUES ('" + url + "', 0);");
    	//db.insert("feed", null, content);
    }
    
    public void delete (String url) {
//    	String [] args = {url};
    	db.execSQL("DELETE FROM feed WHERE url='" + url + "';");
//    	db.delete ("feed", "url=?", args);
    }
    
/*    private int getVisit (String url) {
    	String [] selectionArgs = {url};
    	String [] columns = {"visit"};
    	
    	Cursor c = db.query ("visit", columns, "url=?", selectionArgs, null, null, null);
    	return c.getInt (1);
    }
    
    private void addVisit (String url) {
    	ContentValues content = new ContentValues ();
    	content.put ("visit", getVisit ("url") + 1);
    	
    	String [] args = {url};
    	
    	db.update("feed", content, "url=?", args);
    }*/
        
    private void createDb () {
    	String sql;
    	
    	/* Command to view the DB : sqlite3 data/data/net.lapinblanc.android.rssreader/databases/rssreader */
    	
        try {
        	// Create the database
			db = rss.createDatabase ("rssreader", 1, rss.MODE_PRIVATE, null);
			sql = "CREATE TABLE IF NOT EXISTS feed(_id INTEGER PRIMARY KEY, url TEXT, visit INTEGER);";
			db.execSQL (sql);
			
			// Insert un example
			add ("http://lapin-blanc.net/feed/");
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
}