package net.lapinblanc.android.rssreader;

import android.app.ListActivity;
import android.database.Cursor;
import android.os.Bundle;
import android.view.Menu;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.webkit.*;


public class RSSreader extends ListActivity {
	private Cursor cursor;
	private WebView wv;
	private EditText et;
	private Menu menu;
	private String url;
	private Database db;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle icicle) {    	
        super.onCreate(icicle);
        db = new Database (this);
        display ();
    }
    
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	/* Create two menu entries */
        boolean result = super.onCreateOptionsMenu(menu);
        
        this.menu = menu;
        /* The delete item */
        this.menu.add(0, 0, "Supprimer");
        /* The about item */
        this.menu.add(0, 1, " propos");
        
        //this.menu.setItemShown (0, false);
        return result;
    }
    
    @Override
    public boolean onOptionsItemSelected(Menu.Item item) {
    	/* Do when a menu item is clicked */
        switch (item.getId()) {
        case 0:
        	/* Delete the selected item */
        	deleteItem ();
        	return true;
        case 1:
        	/* Show a box with some data about the program */
        	showAlert (" propos", 0, "Lecteur de flux RSS crit par Kvin Dunglas  des fins de dmonstration pour la plate-forme Google Android.", "Ok", false);
            return true;
        }
        return false;
    }
    
    private void display () {
        /* Create the main screen */
        
		/* Draw the list of feeds */
        drawList ();
        /* Set the content view with the main layout */
        setContentView(R.layout.main);
       
        /* Get views we will use */
        et = (EditText) findViewById(R.id.url);
        wv = (WebView) findViewById (R.id.view);

        /* Display some instructions into the Webview */
        wv.loadData("<html><head><title>Lecteur de flux RSS</title><style type=\"text/css\">body, html {background-color: #ffd800;}</style></head><body><h1>Lecteur de flux RSS</h1><p>Cliquez sur l'un de vos flux pour l'afficher.</p></body></html>", "text/html", "utf-8");

        
        final Button button = (Button) findViewById(R.id.ok);
        button.setOnClickListener(new Button.OnClickListener() {
            public void onClick(View v) {
                /* Perform action on click on the button called "add" */
            	
            	/* Add the feed */
            	db.add (et.getText().toString());
            	/* Display a message box */
            	showAlert ("Feed ajout", 0, "Vous tes maintenant abonn  " + et.getText().toString(), "Ok", false);
            	/* Blank the field */
            	et.setText("http://");
            	/* Refresh the feed list */
            	drawList ();
            }
        });
    }
    
    private void deleteItem () {
    	/* Delete the selected feed */
    	if (this.url == null) {
    		/* Show an alert when no feed is selected */
        	showAlert (" propos", 0, "Vous n'avez pas slectionn d'URL.", "Ok", false);
    		return;
    	}
    	/* Delete the selected feed from the database */
    	db.delete (this.url);
    	showAlert ("Feed supprim", 0, this.url + " a bien t supprim.", "Ok", false);
    	/* Refresh the feed list */
    	drawList ();
    }
    
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	super.onListItemClick (l, v, position, id);    	

    	this.url = cursor.getString (1);
    	//this.menu.setItemShown(0, true);
    	
    	/* Debug purpose - display a test page when no network is available */
        wv.loadData("<html><head><title>Lecteur de flux RSS</title><style type=\"text/css\">body, html {background-color: #ffd800;}</style></head><body><p>Connexion  <a href=\"" + url +"\">" + url + "</a>...</p></body></html>", "text/html", "utf-8");
        
    	/* Load the selected feed */
    	wv.loadUrl(this.url);
    }
    
    private void drawList () {
    	/* Draw or refresh the feeds list */
    	cursor = db.list ();
    	String [] from = {"url"};
    	int [] to = {R.id.feed_item};
    	
    	/* Use a SimpleCursorAdapter */
    	setListAdapter (new SimpleCursorAdapter(this, R.layout.feed_list, cursor, from, to));
    }
    
}